#region Using

using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Net;
using System.Data;
using BlogEngine.Core;
using BlogEngine.Core.Web.Controls;

#endregion

[Extension("Automatically adds navagation links to the top of all pages.", "1.0", "Createdbyx.com")]
public class xPagePathNav
{
    public xPagePathNav()
    {
        Page.Serving += new EventHandler<ServingEventArgs>(Page_CommentServing);
    }

    /// <summary>
    /// The event handler that is triggered every time a comment is served to a client.
    /// </summary>
    private void Page_CommentServing(object sender, ServingEventArgs e)
    {
        Page page = sender as Page;
        System.Collections.Generic.Stack<string> list = new System.Collections.Generic.Stack<string>();

        Page tmpPage = page;
        while (tmpPage.Parent != Guid.Empty)
        {
            Page pPage = BlogEngine.Core.Page.GetPage(tmpPage.Parent);
            string tmp = "<a href=\"" + pPage.AbsoluteLink + "\">" + pPage.Title + "</a>";
            list.Push(tmp);
            tmpPage = pPage;
        }

        string links = string.Empty;
        bool firstrun = true;
        int startdepth = 0;
        if (list.Count == 1) list.Pop();
        while (list.Count > startdepth)
        {
            links = links + (firstrun ? string.Empty : " > ") + list.Pop();
            firstrun = false;
        }

       // links += (links == string.Empty ? string.Empty : " > ") + page.Title;
        e.Body = (links != string.Empty ? "<div class=\"xPagePathNav\">" + links + "</div>" : string.Empty) + e.Body;
    }
}
